//+------------------------------------------------------------------+
//|                                                201111_090802.mqh |
//|                                    2019-2020, dimitri pecheritsa |
//|                                                 792112@gmail.com |
//+------------------------------------------------------------------+
#include <Mqh\201111_091110.mqh> //push concrete subject

//+------------------------------------------------------------------+
//| concrete observer                                                |
//+------------------------------------------------------------------+
class ConcreteObserver:public Observer
  {
public:
   void              Update(string state);
                     ConcreteObserver(ConcreteSubject& subject);
protected:
   string            m_observer_state;
   ConcreteSubject*  m_subject;
  };


//+------------------------------------------------------------------+
//| constructor                                                      |
//+------------------------------------------------------------------+
ConcreteObserver::ConcreteObserver(ConcreteSubject& subject):
   m_subject(&subject)
  {
  }


//+------------------------------------------------------------------+
//| update                                                           |
//+------------------------------------------------------------------+
void ConcreteObserver::Update(string state)
  {
   m_observer_state=state;
   Print("observer ",&this," state updated to: ",m_observer_state);
  }
//+------------------------------------------------------------------+
